=== debian/changelog ===
rehex (0.63.4-0~ubuntu2510) questing; urgency=low

  * Save selected value colour map in default view (#268).

  * Fix blurry text/icons when using DPI scaling under moden Windows (#267).

  * Fix crash when pressing enter in search for value and search for byte
    sequence dialogs (#272).

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Sun, 23 Nov 2025 15:04:56 +0000

rehex (0.63.3-0~ubuntu2510) questing; urgency=low

  * Add option to change bitmap visualisation image background to a
    chosen colour (#258).

  * Copy and save full-size image with alpha channel from bitmap
    visualisation instead of the preview image.

  * Add light icons for use with dark themes to bitmap visualisation and
    histogram views (#262).

  * Add search history to text search dialog (#260).

  * Work around crash with large bitmap previews on Linux (#263).

  * Improve performance of bitmap visualisation.

  * Added missing MOS6502 and Motorola 6800/68k disassembly support for
    x86 Windows (#264).

  * Added RISC-V and WASM disassembly support (where supported by host
    Capstone library).

  * Implement tool panel detaching/docking under Wayland (#252).

  * Update detached tool window title when tab is changed.

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Wed, 15 Oct 2025 23:03:18 +0100

rehex (0.63.2-0~ubuntu2504) plucky; urgency=low

  * Add missing file required for binary template support.

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Sun, 13 Jul 2025 15:57:02 +0100

rehex (0.63.1-0~ubuntu2504) plucky; urgency=low

  * Improve performance of templates that declare large numbers of file
    variables.

  * Fix selecting the byte range encapsulated by a comment (#255).

  * Add "Jump to end" command to comments panel context menu (#254).

  * Improve rendering performance and UI responsiveness, particularly
    when a large number of colours are in use (#257).

  * Fix searching within a range.

  * Default to selection when a range is selected prior to opening
    search dialog (#256).

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Sun, 13 Jul 2025 15:22:02 +0100

rehex (0.63.0-0~ubuntu2504) plucky; urgency=low

  * Add non-modal "Jump to offset" dialog option (#242).

  * Add "Repeat last 'Jump to offset'" command (#242).

  * Add "Visual Scrollbar" for high-level overview of file contents.

  * Add "Data visualisation" tool for overfiew of file/selection
    contents (#230).

  * Add metadata import/export commands (#248).

  * Fix crash when <charset = "US-ASCII"> is specified for a file variable
    in a template (#246).

  * Add highlight functions to scripting API and template language (#247).

  * Fix memory leaks in bitmap preview tool and metadata serialisation.

  * Suspend scanning for strings when the strings tool is hidden.

  * Fix the continue/reset buttons in the strings tool not working
    correctly.

  * Fix horizontal scroll position being set out-of-range when the window is
    resized in some situations.

  * Fix bitmap preview tool not following cursor correctly (#244).

  * Allow detaching tool panels to floating windows or docking them to any
    side of the main window (#229).

  * Reduce unnecessary padding in decimal offsets (#235).

  * Fix range selection input for checksum/histogram on macOS.

  * Fix selection being prematurely initiated when the mouse is clicked
    over file data.

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Thu, 12 Jun 2025 11:47:37 +0100

rehex (0.62.0-0~ubuntu2504) plucky; urgency=low

  * Add bit array data type (#167).

  * Allow selecting and setting comments/highlights/types on
    bit-sized/aligned quantities, not just byte-aligned (#155).

  * Allow defining arbitrary integer types, up to 64 bits wide (#215).

  * Allow colouring data by byte value (#223).

  * Allow changing/defining custom highlight colours and assigning
    labels to them (#227).

  * Use dimmer highlight colours for dark colour schemes (#227).

  * Save highlight colours/labels per-file (#60).

  * Allow changing keyboard shortcuts (#226).

  * Add Shift+Enter shortcut for "OK" in the comment dialog (#226).

  * Display offset in both decimal and hexadecimal in status bar (#228).

  * Fix handling of relative paths specified on the command line when
    opening in an existing instance (#237).

  * Allow navigating hex data by nibbles rather than bytes (#58).

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Fri, 02 May 2025 01:11:13 +0100

rehex (0.61.1-0~ubuntu2404) noble; urgency=low

  * Compare data from correct file offsets when "Collapse matches" option is
    enabled in compare window (#224).

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Sun, 05 May 2024 19:54:32 +0100
